//   ***************************************************************************************************
//   ***************************************************************************************************
//   ***************************************************************************************************
//   K1 Improved Barrier (sa_bar_imp.nss).
//   Created by Star Admiral.
//   Last Modified on 01/14/09.
//   ***************************************************************************************************
//   ***************************************************************************************************
//   ***************************************************************************************************

// Include custom functions for spell casting.
#include "sa_inc_force"

void main() {

   // Set the bonuses and penalties given by the spell.
   effect eResist = EffectDamageResistance( DAMAGE_TYPE_BLUDGEONING, 15, 0 );
   eResist = EffectLinkEffects( eResist, EffectDamageResistance( DAMAGE_TYPE_PIERCING, 15, 0 ) );
   eResist = EffectLinkEffects( eResist, EffectDamageResistance( DAMAGE_TYPE_SLASHING, 15, 0 ) );
   // Set the effect icon for the spell.
   eResist = SetEffectIcon( eResist, SA_BAR_I_IMP );
   // Set the visuals shown by the spell.
   effect eVisual = EffectVisualEffect( 1010, FALSE );
   eVisual = EffectLinkEffects( eVisual, EffectVisualEffect( 1026, FALSE ) );
   // Check if the character is not a party member.
   if( !IsObjectPartyMember( OBJECT_SELF ) ) {
      // Remove the spell effects if it exists already.
      SA_RemoveEffectSingle( SA_BARRIER_REG, OBJECT_SELF );
      SA_RemoveEffectSingle( SA_BARRIER_IMP, OBJECT_SELF );
      // Apply the effects to the character.
      SA_ApplySpecialSingle( OBJECT_SELF, DURATION_TYPE_INSTANT, eVisual, 0.00 );
      SA_ApplyEffectSingle( SA_BARRIER_REG, OBJECT_SELF, FALSE, DURATION_TYPE_TEMPORARY, eResist, 120.00 );
   }
   // If the character is a party member, apply the effect to the entire party.
   else {
      // Remove the spell effect if it exists already.
      SA_RemoveEffectParty( SA_BARRIER_REG );
      SA_RemoveEffectParty( SA_BARRIER_IMP );
      // Apply the effects to the entire party.
      SA_ApplySpecialParty( DURATION_TYPE_INSTANT, eVisual, 0.00 );
      SA_ApplyEffectParty( SA_BARRIER_REG, FALSE, DURATION_TYPE_TEMPORARY, eResist, 120.00 );
   }

}
