//   ***************************************************************************************************
//   ***************************************************************************************************
//   ***************************************************************************************************
//   K1 Force Camouflage (sa_cam_two.nss).
//   Created by Star Admiral.
//   Last Modified on 01/14/09.
//   ***************************************************************************************************
//   ***************************************************************************************************
//   ***************************************************************************************************

// Include custom functions for spell casting.
#include "sa_inc_force"

void main() {

   // Set the effects for stealth mode.
   effect eStealth = EffectInvisibility( INVISIBILITY_TYPE_NORMAL );
   eStealth = EffectLinkEffects( eStealth, EffectVisualEffect( 8000, FALSE ) );
   // Set the effect icon for the spell.
   eStealth = SetEffectIcon( eStealth, SA_CAM_I_TWO );
   // Set the visuals shown by the spell.
   effect eVisual = EffectVisualEffect( 8001, FALSE );
   // Check if the character is not a party member.
   if( !IsObjectPartyMember( OBJECT_SELF ) ) {
      // Remove the spell effects if it exists already.
      SA_RemoveEffectSingle( SA_STEALTH_ONE, OBJECT_SELF );
      SA_RemoveEffectSingle( SA_CAMOUFLAGE_TWO, OBJECT_SELF );
      // Apply the effects to the character.
      SA_ApplySpecialSingle( OBJECT_SELF, DURATION_TYPE_INSTANT, eVisual, 0.00 );
      DelayCommand( 0.25, SA_ApplyEffectSingle( SA_CAMOUFLAGE_TWO, OBJECT_SELF, FALSE, DURATION_TYPE_TEMPORARY, eStealth, 30.00 ) );
      // Get the targeted character.
      object oTarget = GetFirstObjectInArea( OBJECT_INVALID, OBJECT_TYPE_CREATURE );
      // Loop through each target within the sphere of effect.
      while ( GetIsObjectValid( oTarget ) ) {
         // If target notices player but fails awareness check, clear action queue to forget player.
         if( GetIsEnemy( oTarget ) && ( GetAttackTarget( oTarget ) == OBJECT_SELF ) && ( GetSkillRank( 3, oTarget ) <= ( GetSkillRank( 2, OBJECT_SELF ) + 8 ) ) )
            AssignCommand( oTarget, ClearAllActions() );
         // Get the next target in the sphere of effect.
         oTarget = GetNextObjectInArea( OBJECT_INVALID, OBJECT_TYPE_CREATURE );
      }
   }
   // If the character is a party member, apply the effect to the entire party.
   else {
      // Remove the spell effect if it exists already.
      SA_RemoveEffectParty( SA_STEALTH_ONE );
      SA_RemoveEffectParty( SA_CAMOUFLAGE_TWO );
      // Apply the effects to the entire party.
      SA_ApplySpecialParty( DURATION_TYPE_INSTANT, eVisual, 0.00 );
      DelayCommand( 0.25, SA_ApplyEffectParty( SA_CAMOUFLAGE_TWO, FALSE, DURATION_TYPE_TEMPORARY, eStealth, 30.00 ) );
      // Get the targeted character.
      object oTarget = GetFirstObjectInArea( OBJECT_INVALID, OBJECT_TYPE_CREATURE );
      // Loop through each target within the sphere of effect.
      while ( GetIsObjectValid( oTarget ) ) {
         // If target notices player but fails awareness check, clear action queue to forget player.
         if( GetIsEnemy( oTarget ) && ( GetAttackTarget( oTarget ) == OBJECT_SELF ) && ( GetSkillRank( 3, oTarget ) <= ( GetSkillRank( 2, OBJECT_SELF ) + 8 ) ) )
            AssignCommand( oTarget, ClearAllActions() );
         // Get the next target in the sphere of effect.
         oTarget = GetNextObjectInArea( OBJECT_INVALID, OBJECT_TYPE_CREATURE );
      }
   }

}