//   ***************************************************************************************************
//   ***************************************************************************************************
//   ***************************************************************************************************
//   K1 Improved Energize (sa_ene_imp.nss).
//   Created by Star Admiral.
//   Last Modified on 01/14/09.
//   ***************************************************************************************************
//   ***************************************************************************************************
//   ***************************************************************************************************

// Include custom functions for spell casting.
#include "sa_inc_force"

void main() {

   // Set the amount of temporary health points.
   int nHitpoints = 2 * GetHitDice( OBJECT_SELF );
   // Set the amount of health and Force points to restore.
   int nRestore = 10 + GetAbilityModifier( ABILITY_WISDOM, OBJECT_SELF ) + GetAbilityModifier( ABILITY_CHARISMA, OBJECT_SELF );
   // Set the bonuses and penalties given by the spell.
   effect eEnergize = EffectTemporaryHitpoints( nHitpoints );
   effect eRestore = EffectHeal( nRestore );
   eRestore = EffectLinkEffects( eRestore, EffectHealForcePoints( nRestore ) );
   // Set the effect icon for the spell.
   eEnergize = SetEffectIcon( eEnergize, SA_ENE_I_IMP );
   // Set the visuals shown by the spell.
   effect eVisual = EffectVisualEffect( 1028, FALSE );
   eVisual = EffectLinkEffects( eVisual, EffectVisualEffect( 1047, FALSE ) );
   // Check if the character is not a party member.
   if( !IsObjectPartyMember( OBJECT_SELF ) ) {
      // Remove the spell effects if it exists already.
      SA_RemoveEffectSingle( SA_ENERGIZE_REG, OBJECT_SELF );
      SA_RemoveEffectSingle( SA_ENERGIZE_IMP, OBJECT_SELF );
      // Apply the effects to the character.
      SA_ApplySpecialSingle( OBJECT_SELF, DURATION_TYPE_INSTANT, eVisual, 0.00 );
      SA_ApplyEffectSingle( SA_ENERGIZE_IMP, OBJECT_SELF, FALSE, DURATION_TYPE_TEMPORARY, eEnergize, 30.00 );
      SA_IterativeSingle( OBJECT_SELF, DURATION_TYPE_TEMPORARY, eRestore, 30.00, 3.00 );
   }
   // If the character is a party member, apply the effect to the entire party.
   else {
      // Remove the spell effect if it exists already.
      SA_RemoveEffectParty( SA_ENERGIZE_REG );
      SA_RemoveEffectParty( SA_ENERGIZE_IMP );
      // Apply the effects to the character.
      SA_ApplySpecialParty( DURATION_TYPE_INSTANT, eVisual, 0.00 );
      SA_ApplyEffectParty( SA_ENERGIZE_IMP, FALSE, DURATION_TYPE_TEMPORARY, eEnergize, 30.00 );
      SA_IterativeParty( DURATION_TYPE_TEMPORARY, eRestore, 30.00, 3.00 );
   }

}
