//   ***************************************************************************************************
//   ***************************************************************************************************
//   ***************************************************************************************************
//   K1 Force Barrier (sa_bar_reg.nss).
//   Created by Star Admiral.
//   Last Modified on 01/14/09.
//   ***************************************************************************************************
//   ***************************************************************************************************
//   ***************************************************************************************************

// Include custom functions for spell casting.
#include "sa_inc_force"

void main() {

   // If the spell's higher levels have not yet been cast by the character, cast the spell, else, do nothing.
   if( !GetHasSpellEffect( SA_BARRIER_IMP, OBJECT_SELF ) ) {
      // Set the bonuses and penalties given by the spell.
      effect eResist = EffectDamageResistance( DAMAGE_TYPE_BLUDGEONING, 15, 0 );
      eResist = EffectLinkEffects( eResist, EffectDamageResistance( DAMAGE_TYPE_PIERCING, 15, 0 ) );
      eResist = EffectLinkEffects( eResist, EffectDamageResistance( DAMAGE_TYPE_SLASHING, 15, 0 ) );
      // Set the effect icon for the spell.
      eResist = SetEffectIcon( eResist, SA_BAR_I_REG );
      // Set the visuals shown by the spell.
      effect eVisual = EffectVisualEffect( 1010, FALSE );
      eVisual = EffectLinkEffects( eVisual, EffectVisualEffect( 1026, FALSE ) );
      // Remove the spell effect if it exists already.
      SA_RemoveEffectSingle( SA_BARRIER_REG, OBJECT_SELF );
      // Apply the spell effects to the character.
      SA_ApplySpecialSingle( OBJECT_SELF, DURATION_TYPE_INSTANT, eVisual, 0.00 );
      SA_ApplyEffectSingle( SA_BARRIER_REG, OBJECT_SELF, FALSE, DURATION_TYPE_TEMPORARY, eResist, 120.00 );
   }

}
