//   ***************************************************************************************************
//   ***************************************************************************************************
//   ***************************************************************************************************
//   K1 Determination Proficiency (sa_det_pro.nss).
//   Created by Star Admiral.
//   Last Modified on 01/14/09.
//   ***************************************************************************************************
//   ***************************************************************************************************
//   ***************************************************************************************************

// Include custom functions for spell casting.
#include "sa_inc_force"

void main() {

   // If the form's higher levels have not yet been cast by the character, cast the form, else, do nothing.
   if( !GetHasSpellEffect( SA_DETERMINATION_MAS, OBJECT_SELF ) ) {
      // Set the bonuses and penalties given by the form.
      effect eForm = EffectAttackIncrease( 1, ATTACK_BONUS_MISC );
      eForm = EffectLinkEffects( eForm, EffectACIncrease( 1, AC_DODGE_BONUS, AC_VS_DAMAGE_TYPE_ALL ) );
      // Set the effect icon for the form.
      eForm = SetEffectIcon( eForm, SA_DET_I_PRO );
      // Remove any other form currently active on the character.
      SA_RemoveEffectSingle( SA_DETERMINATION_PRO, OBJECT_SELF );
      SA_RemoveEffectSingle( SA_CONTENTION_PRO, OBJECT_SELF );
      SA_RemoveEffectSingle( SA_CONTENTION_MAS, OBJECT_SELF );
      SA_RemoveEffectSingle( SA_RESILIENCE_PRO, OBJECT_SELF );
      SA_RemoveEffectSingle( SA_RESILIENCE_MAS, OBJECT_SELF );
      SA_RemoveEffectSingle( SA_AGGRESSION_PRO, OBJECT_SELF );
      SA_RemoveEffectSingle( SA_AGGRESSION_MAS, OBJECT_SELF );
      SA_RemoveEffectSingle( SA_PERSEVERANCE_PRO, OBJECT_SELF );
      SA_RemoveEffectSingle( SA_PERSEVERANCE_MAS, OBJECT_SELF );
      SA_RemoveEffectSingle( SA_MODERATION_PRO, OBJECT_SELF );
      SA_RemoveEffectSingle( SA_MODERATION_MAS, OBJECT_SELF );
      SA_RemoveEffectSingle( SA_FEROCITY_PRO, OBJECT_SELF );
      SA_RemoveEffectSingle( SA_FEROCITY_MAS, OBJECT_SELF );
      // Apply the form to the character.
      SA_ApplyEffectSingle( SA_DETERMINATION_PRO, OBJECT_SELF, FALSE, DURATION_TYPE_TEMPORARY, eForm, 120.00 );
   }

}
