//   ***************************************************************************************************
//   ***************************************************************************************************
//   ***************************************************************************************************
//   K1 Knight Meditation (sa_med_kni.nss).
//   Created by Star Admiral.
//   Last Modified on 01/14/09.
//   ***************************************************************************************************
//   ***************************************************************************************************
//   ***************************************************************************************************

// Include custom functions for spell casting.
#include "sa_inc_force"

void main() {

   // If the spell's higher levels have not yet been cast by the character, cast the spell, else, do nothing.
   if( !GetHasSpellEffect( SA_MEDITATION_MAS, OBJECT_SELF ) ) {
      // Set the bonuses and penalties given by the spell.
      effect eMeditation = EffectAttackIncrease( 4, ATTACK_BONUS_MISC );
      eMeditation = EffectLinkEffects( eMeditation, EffectACIncrease( 4, AC_DODGE_BONUS, AC_VS_DAMAGE_TYPE_ALL ) );
      eMeditation = EffectLinkEffects( eMeditation, EffectSavingThrowIncrease( SAVING_THROW_WILL, 4, SAVING_THROW_TYPE_ALL ) );
      // Set the effect icon for the spell.
      eMeditation = SetEffectIcon( eMeditation, SA_MED_I_KNI );
      // Set the visuals shown by the spell.
      effect eVisual = EffectVisualEffect( 1012, FALSE );
      eVisual = EffectLinkEffects( eVisual, EffectVisualEffect( 1015, FALSE ) );
      // Check if the character is not a party member.
      if( !IsObjectPartyMember( OBJECT_SELF ) ) {
         // Remove the spell effects if it exists already.
         SA_RemoveEffectSingle( SA_MEDITATION_REG, OBJECT_SELF );
         SA_RemoveEffectSingle( SA_MEDITATION_KNI, OBJECT_SELF );
         // Apply the effects to the character.
         SA_ApplySpecialSingle( OBJECT_SELF, DURATION_TYPE_INSTANT, eVisual, 0.00 );
         SA_ApplyEffectSingle( SA_MEDITATION_REG, OBJECT_SELF, FALSE, DURATION_TYPE_TEMPORARY, eMeditation, 30.00 );
      }
      // If the character is a party member, apply the effect to the entire party.
      else {
         // Remove the spell effect if it exists already.
         SA_RemoveEffectParty( SA_MEDITATION_REG );
         SA_RemoveEffectParty( SA_MEDITATION_KNI );
         // Apply the effects to the entire party.
         SA_ApplySpecialParty( DURATION_TYPE_INSTANT, eVisual, 0.00 );
         SA_ApplyEffectParty( SA_MEDITATION_REG, FALSE, DURATION_TYPE_TEMPORARY, eMeditation, 30.00 );
      }
   }

}
