//   ***************************************************************************************************
//   ***************************************************************************************************
//   ***************************************************************************************************
//   K1 Force Premonition (sa_pre_two.nss).
//   Created by Star Admiral.
//   Last Modified on 01/14/09.
//   ***************************************************************************************************
//   ***************************************************************************************************
//   ***************************************************************************************************

// Include custom functions for spell casting.
#include "sa_inc_force"

void main() {

   // If the spell's higher levels have not yet been cast by the character, cast the spell, else, do nothing.
   if( !GetHasSpellEffect( SA_ENLIGHTENMENT_THR, OBJECT_SELF ) ) {
      // Set the bonuses and penalties given by the spell.
      effect eSense = EffectAttackIncrease( 4, ATTACK_BONUS_MISC );
      eSense = EffectLinkEffects( eSense, EffectBlasterDeflectionDecrease( 4 ) );
      eSense = EffectLinkEffects( eSense, EffectAssuredDeflection( FALSE ) );
      // Set the effect icon for the spell.
      eSense = SetEffectIcon( eSense, SA_PRE_I_TWO );
      // Set the visuals shown by the spell.
      effect eVisual = EffectVisualEffect( 1031, FALSE );
      // Remove the spell effects if it exists already.
      SA_RemoveEffectSingle( SA_SENSE_ONE, OBJECT_SELF );
      SA_RemoveEffectSingle( SA_PREMONITION_TWO, OBJECT_SELF );
      // Apply the effects to the character.
      SA_ApplySpecialSingle( OBJECT_SELF, DURATION_TYPE_INSTANT, eVisual, 0.00 );
      SA_ApplyEffectSingle( SA_PREMONITION_TWO, OBJECT_SELF, FALSE, DURATION_TYPE_TEMPORARY, eSense, 30.00 );
   }

}
