//   ***************************************************************************************************
//   ***************************************************************************************************
//   ***************************************************************************************************
//   K1 Master Protect (sa_pro_mas.nss).
//   Created by Star Admiral.
//   Last Modified on 01/14/09.
//   ***************************************************************************************************
//   ***************************************************************************************************
//   ***************************************************************************************************

// Include custom functions for spell casting.
#include "sa_inc_force"

void main() {

   // If the spell has not yet been cast by the character, cast the spell.
   if( !GetHasSpellEffect( SA_PROTECT_REG, OBJECT_SELF ) || !GetHasSpellEffect( SA_PROTECT_KNI, OBJECT_SELF ) || !GetHasSpellEffect( SA_PROTECT_MAS, OBJECT_SELF ) ) {
      // Set the bonuses and penalties given by the spell.
      effect eProtect = EffectForceShield( SA_PRO_S_MAS );
      eProtect = EffectLinkEffects( eProtect, EffectACIncrease( 4, AC_DODGE_BONUS, AC_VS_DAMAGE_TYPE_ALL ) );
      eProtect = EffectLinkEffects( eProtect, EffectBlasterDeflectionIncrease( 4 ) );
      // Set the effect icon for the spell.
      eProtect = SetEffectIcon( eProtect, SA_PRO_I_MAS );
      // Set the visuals shown by the spell.
         effect eVisual = EffectVisualEffect( 1010, FALSE );
      // Apply the effects to the character.
      SA_ApplySpecialSingle( OBJECT_SELF, DURATION_TYPE_INSTANT, eVisual, 0.00 );
      SA_ApplyEffectSingle( SA_PROTECT_MAS, OBJECT_SELF, FALSE, DURATION_TYPE_TEMPORARY, eProtect, 60.00 );
   }
   // If the spell has already been cast by the character, remove it and restore the used Force points.
   else {
      // Remove the spell effects.
      SA_RemoveEffectSingle( SA_PROTECT_REG, OBJECT_SELF );
      SA_RemoveEffectSingle( SA_PROTECT_KNI, OBJECT_SELF );
      SA_RemoveEffectSingle( SA_PROTECT_MAS, OBJECT_SELF );
      // Set the amount of Force points to restore.
      effect eRestore = EffectHealForcePoints( 30 );
      // Restore the used Force points.
      SA_ApplySpecialSingle( OBJECT_SELF, DURATION_TYPE_INSTANT, eRestore, 0.00 );
   }

}
