//   ***************************************************************************************************
//   ***************************************************************************************************
//   ***************************************************************************************************
//   K1 Force Protect (sa_pro_reg.nss).
//   Created by Star Admiral.
//   Last Modified on 01/14/09.
//   ***************************************************************************************************
//   ***************************************************************************************************
//   ***************************************************************************************************

// Include custom functions for spell casting.
#include "sa_inc_force"

void main() {

   // If the spell has not yet been cast by the character, check if the spell's higher levels have been cast.
   if( !GetHasSpellEffect( SA_PROTECT_REG, OBJECT_SELF ) ) {
      // If the spell's higher levels have not yet been cast, cast the spell.
      if( !GetHasSpellEffect( SA_PROTECT_KNI, OBJECT_SELF ) || !GetHasSpellEffect( SA_PROTECT_MAS, OBJECT_SELF ) ) {
         // Set the bonuses and penalties given by the spell.
         effect eProtect = EffectForceShield( SA_PRO_S_REG );
         // Set the effect icon for the spell.
         eProtect = SetEffectIcon( eProtect, SA_PRO_I_REG );
         // Set the visuals shown by the spell.
         effect eVisual = EffectVisualEffect( 1010, FALSE );
         // Apply the effects to the character.
         SA_ApplySpecialSingle( OBJECT_SELF, DURATION_TYPE_INSTANT, eVisual, 0.00 );
         SA_ApplyEffectSingle( SA_PROTECT_REG, OBJECT_SELF, FALSE, DURATION_TYPE_TEMPORARY, eProtect, 60.00 );
      }
   }
   // If the spell has already been cast by the character, remove it and restore the used Force points.
   else {
      // Remove the spell effects.
      SA_RemoveEffectSingle( SA_PROTECT_REG, OBJECT_SELF );
      // Set the amount of Force points to restore.
      effect eRestore = EffectHealForcePoints( 30 );
      // Restore the used Force points.
      SA_ApplySpecialSingle( OBJECT_SELF, DURATION_TYPE_INSTANT, eRestore, 0.00 );
   }

}
