//   ***************************************************************************************************
//   ***************************************************************************************************
//   ***************************************************************************************************
//   K1 Master Rage (sa_rag_mas.nss).
//   Created by Star Admiral.
//   Last Modified on 01/14/09.
//   ***************************************************************************************************
//   ***************************************************************************************************
//   ***************************************************************************************************

// Include custom functions for spell casting.
#include "sa_inc_force"

void main() {

   // If the spell or its higher levels have not yet been cast by the character, cast the spell.
   if( !GetHasSpellEffect( SA_RAGE_REG, OBJECT_SELF ) && !GetHasSpellEffect( SA_RAGE_IMP, OBJECT_SELF ) && !GetHasSpellEffect( SA_RAGE_MAS, OBJECT_SELF ) ) {
      // Cast the spell only if the character has enough health.
      if( GetCurrentHitPoints( OBJECT_SELF ) > 20 ) {
         // Set the bonuses and penalties given by the spell.
         effect eRage = EffectModifyAttacks( 1 );
         eRage = EffectLinkEffects( eRage, EffectMovementSpeedIncrease( 200 ) );
         eRage = EffectLinkEffects( eRage, EffectAttackIncrease( 4, ATTACK_BONUS_MISC ) );
         // Set the damage dealt to the player for casting the spell.
         effect eDamage = EffectDamage( 20, DAMAGE_TYPE_UNIVERSAL, DAMAGE_POWER_NORMAL );
         // Set the effect icon for the spell.
         eRage = SetEffectIcon( eRage, SA_RAG_I_MAS );
         // Set the visuals shown by the spell.
         effect eVisual = EffectVisualEffect( 1009, FALSE );
         effect eStorm = EffectVisualEffect( 1018, FALSE );
         // Set the speed blur for the spell.
         effect eBlur = EffectVisualEffect( 2031, FALSE );
         eBlur = EffectLinkEffects( eBlur, EffectVisualEffect( 2004, FALSE ) );
         // Apply the effects to the character.
         SetMinOneHP( OBJECT_SELF, TRUE );
         SA_ApplySpecialSingle( OBJECT_SELF, DURATION_TYPE_INSTANT, eVisual, 0.00 );
         SA_ApplySpecialSingle( OBJECT_SELF, DURATION_TYPE_INSTANT, eStorm, 0.00 );
         SA_ApplySpecialSingle( OBJECT_SELF, DURATION_TYPE_INSTANT, eDamage, 0.00 );
         SA_ApplyEffectSingle( SA_RAGE_IMP, OBJECT_SELF, FALSE, DURATION_TYPE_TEMPORARY, eRage, 60.00 );
         // If the character is the main player, apply speed blur effect.
         if( OBJECT_SELF == GetPartyMemberByIndex( 0 ) )
            SA_ApplySpecialSingle( OBJECT_SELF, DURATION_TYPE_TEMPORARY, eBlur, 60.00 );
         // Remove the minimum one vitality point flag.
         DelayCommand( 60.00, SetMinOneHP( OBJECT_SELF, FALSE ) );
      }
      // If the character's health is too low, fizzle out the power and display an explaination.
      else {
         ActionStartConversation( OBJECT_SELF, "sa_rag_hea", FALSE, 0, FALSE, "", "", "", "", "", "", FALSE );
         ApplyEffectToObject( DURATION_TYPE_INSTANT, EffectForceFizzle(), OBJECT_SELF );
      }
   }
   // If the spell or its higher levels are already active, fizzle out the power and display an explaination.
   else {
      ActionStartConversation( OBJECT_SELF, "sa_rag_wai", FALSE, 0, FALSE, "", "", "", "", "", "", FALSE );
      ApplyEffectToObject( DURATION_TYPE_INSTANT, EffectForceFizzle(), OBJECT_SELF );
   }

}
